#include "Mikromedia_7_Demo_objects.h"
#include "bsp_flash_driver.h"
#include "config_module.h"

/* ------------------------------------------------------------------- MACROS */

#define ETH_MAC_ADDRESS_LOCATION    (uint32_t)(0x00000000)
#define ETH_IP_ADDRESS_LOCATION     (uint32_t)(0x00000000)
#define ETH_NETMASK_LOCATION        (uint32_t)(0x00000000)
#define ETH_GATEWAY_LOCATION        (uint32_t)(0x00000000)
#define ETH_DNS_LOCATION            (uint32_t)(0x00000000)

#define WIFI_SSID_LOCATION
#define WIFI_PASS_LOCATION

#define RF_TX_CHANNEL_PIPE
#define RF_RX_CHANNEL_PIPE

/* ---------------------------------------------------------------- VARIABLES */

static uint8_t          data_updated;
static module_t         config_module;

#if ( _MMB_MODULE_ETHERNET == 1 )

    static uint8_t mac[6];
    static uint8_t ip[4];
    static uint8_t netmask[4];
    static uint8_t gateway[4];
    static uint8_t dns[4];

#endif

/* -------------------------------------------- PRIVATE FUNCTION DECLARATIONS */

static void config_store_data ( void );

static void config_restore_data ( void );

/* ----------------------------------------------------------- IMPLEMENTATION */

/*
    Called from system initialization procedure.
*/

void config_module_init ( module_t ** module )
{
    config_module.state = MODULE_INACTIVE;
    config_module.menu = MENU_COLLAPSED;

    data_updated = 0;

    //  Initialize FLASH.
    // ...


    // ...


    config_restore_data( );
    
    *module = &config_module;
}

void config_module_task ( void )
{
    switch ( config_module.state )
    {
        case MODULE_INACTIVE :
        {
            DrawScreen( &Screen_02_Config );

            data_updated = 0;
            config_module.menu = MENU_COLLAPSED;
            config_module.state = MODULE_ACTIVE;
            
            break;
        }
        case MODULE_ACTIVE :
        {
            switch ( config_module.menu )
            {
                case MENU_COLLAPSED :
                {
                    /*  
                        Read data and update labels only in case we came here 
                        for the first time.
                    */

                    if ( data_updated == 0 )
                    {   
                        
                        //  ...


                        //  ...

                        data_updated = 1;
                    }

                    break;
                }
                case MENU_EXPANDED :
                {
                

                    break;
                }
            }

            break;
        }
        default :
        {
            /* ERROR */
                
            break;
        }
    }
}

/* --------------------------------------------- PRIVATE FUNCTION DEFINITIONS */

static void config_store_data ( void )
{
    bsp_flash_chip_erase( );

#if ( _MMB_MODULE_ETHERNET == 1 )

    bsp_flash_write( ETH_MAC_ADDRESS_LOCATION, mac, 6 );
    bsp_flash_write( ETH_IP_ADDRESS_LOCATION, ip, 4 );
    bsp_flash_write( ETH_NETMASK_LOCATION, netmask, 4 );
    bsp_flash_write( ETH_GATEWAY_LOCATION, gateway, 4 );
    bsp_flash_write( ETH_DNS_LOCATION, dns, 4 );

#endif

}

static void config_restore_data ( void )
{

#if ( _MMB_MODULE_ETHERNET == 1 )

    bsp_flash_read( ETH_MAC_ADDRESS_LOCATION, mac, 6 );
    bsp_flash_read( ETH_IP_ADDRESS_LOCATION, ip, 4 );
    bsp_flash_read( ETH_NETMASK_LOCATION, netmask, 4 );
    bsp_flash_read( ETH_GATEWAY_LOCATION, gateway, 4 );
    bsp_flash_read( ETH_DNS_LOCATION, dns, 4 );

#endif

}